package com.intuit.payments.qa.tests;

import java.math.BigDecimal;

import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.DefaultTable;
import org.dbunit.dataset.IDataSet;

import com.intuit.tame.db.DBUnitTestUtilities;

public class MerchantStatusHistory {
    IDatabaseConnection connection;
    IDataSet            helperDataSet;
    IDataSet            dataSet;
    String              merchantAccountNumber;
    Object              dda;
    String              trn;
    BigDecimal          merchantAccountEid;

    public MerchantStatusHistory(IDatabaseConnection connection, IDataSet dataSet, String object_change_id) throws Exception {
        this.dataSet = dataSet;
        this.helperDataSet = DBUnitTestUtilities.loadXmlDataSet("/helperSql.xml");
        this.merchantAccountNumber = Utility.getMerchantAccountNumber(connection, helperDataSet);
        this.merchantAccountEid = Utility.getMerchantAccountEid(connection, helperDataSet, merchantAccountNumber);
        this.trn = Utility.getTrn(connection, helperDataSet);
        this.dda = Utility.getDda(connection, helperDataSet);
        this.object_change_id = object_change_id;
        this.connection = connection;
    }

    DefaultTable prepare() throws Exception {
        DefaultTable table = (DefaultTable) dataSet.getTable("oasis_owner.merchant_status_history");
        String nextValSql = (String) dataSet.getTable("sequenceNextval").getValue(0, "sql");
        for (int i = 0; i < table.getRowCount(); i++) {
            BigDecimal nextVal = (BigDecimal) connection.createQueryTable("nextval", nextValSql).getValue(0, "NEXTVAL");
            table.setValue(i, "EID", nextVal);
            table.setValue(i, "MERCHANTACCOUNTNUMBER", merchantAccountNumber);
            table.setValue(i, "TRANSITROUTINGNUMBER", trn);
            table.setValue(i, "DDAGLSAVINGS", dda);
            table.setValue(i, "MERCHANTACCOUNTEID", merchantAccountEid);
            table.setValue(i, "OBJECT_CHANGE_ID", object_change_id);
        }
        return table;
    }

}
